Index: XIOS/trunk/src/interface/fortran_attr/filegroup_interface_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/filegroup_interface_attr.F90	(revision 886)
+++ XIOS/trunk/src/interface/fortran_attr/filegroup_interface_attr.F90	(revision 891)
@@ -48,4 +48,23 @@
 
 
+    SUBROUTINE cxios_set_filegroup_cyclic(filegroup_hdl, cyclic) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: filegroup_hdl
+      LOGICAL (KIND=C_BOOL)      , VALUE :: cyclic
+    END SUBROUTINE cxios_set_filegroup_cyclic
+
+    SUBROUTINE cxios_get_filegroup_cyclic(filegroup_hdl, cyclic) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: filegroup_hdl
+      LOGICAL (KIND=C_BOOL)             :: cyclic
+    END SUBROUTINE cxios_get_filegroup_cyclic
+
+    FUNCTION cxios_is_defined_filegroup_cyclic(filegroup_hdl) BIND(C)
+      USE ISO_C_BINDING
+      LOGICAL(kind=C_BOOL) :: cxios_is_defined_filegroup_cyclic
+      INTEGER (kind = C_INTPTR_T), VALUE :: filegroup_hdl
+    END FUNCTION cxios_is_defined_filegroup_cyclic
+
+
     SUBROUTINE cxios_set_filegroup_description(filegroup_hdl, description, description_size) BIND(C)
       USE ISO_C_BINDING
Index: XIOS/trunk/src/interface/fortran_attr/ifield_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/ifield_attr.F90	(revision 886)
+++ XIOS/trunk/src/interface/fortran_attr/ifield_attr.F90	(revision 891)
@@ -14,5 +14,5 @@
     ( field_id, add_offset, axis_ref, compression_level, default_value, detect_missing_value, domain_ref  &
     , enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, indexed_output, level, long_name  &
-    , name, operation, prec, read_access, scale_factor, standard_name, ts_enabled, ts_split_freq  &
+    , name, operation, prec, read_access, scalar_ref, scale_factor, standard_name, ts_enabled, ts_split_freq  &
     , unit, valid_max, valid_min )
 
@@ -43,4 +43,5 @@
       LOGICAL  , OPTIONAL, INTENT(IN) :: read_access
       LOGICAL (KIND=C_BOOL) :: read_access_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: scalar_ref
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: scale_factor
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: standard_name
@@ -56,5 +57,5 @@
       ( field_hdl, add_offset, axis_ref, compression_level, default_value, detect_missing_value, domain_ref  &
       , enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, indexed_output, level, long_name  &
-      , name, operation, prec, read_access, scale_factor, standard_name, ts_enabled, ts_split_freq  &
+      , name, operation, prec, read_access, scalar_ref, scale_factor, standard_name, ts_enabled, ts_split_freq  &
       , unit, valid_max, valid_min )
 
@@ -64,5 +65,5 @@
     ( field_hdl, add_offset, axis_ref, compression_level, default_value, detect_missing_value, domain_ref  &
     , enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, indexed_output, level, long_name  &
-    , name, operation, prec, read_access, scale_factor, standard_name, ts_enabled, ts_split_freq  &
+    , name, operation, prec, read_access, scalar_ref, scale_factor, standard_name, ts_enabled, ts_split_freq  &
     , unit, valid_max, valid_min )
 
@@ -92,4 +93,5 @@
       LOGICAL  , OPTIONAL, INTENT(IN) :: read_access
       LOGICAL (KIND=C_BOOL) :: read_access_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: scalar_ref
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: scale_factor
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: standard_name
@@ -104,5 +106,5 @@
       ( field_hdl, add_offset, axis_ref, compression_level, default_value, detect_missing_value, domain_ref  &
       , enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, indexed_output, level, long_name  &
-      , name, operation, prec, read_access, scale_factor, standard_name, ts_enabled, ts_split_freq  &
+      , name, operation, prec, read_access, scalar_ref, scale_factor, standard_name, ts_enabled, ts_split_freq  &
       , unit, valid_max, valid_min )
 
@@ -112,5 +114,5 @@
     ( field_hdl, add_offset_, axis_ref_, compression_level_, default_value_, detect_missing_value_  &
     , domain_ref_, enabled_, field_ref_, freq_offset_, freq_op_, grid_path_, grid_ref_, indexed_output_  &
-    , level_, long_name_, name_, operation_, prec_, read_access_, scale_factor_, standard_name_  &
+    , level_, long_name_, name_, operation_, prec_, read_access_, scalar_ref_, scale_factor_, standard_name_  &
     , ts_enabled_, ts_split_freq_, unit_, valid_max_, valid_min_ )
 
@@ -140,4 +142,5 @@
       LOGICAL  , OPTIONAL, INTENT(IN) :: read_access_
       LOGICAL (KIND=C_BOOL) :: read_access__tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: scalar_ref_
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: scale_factor_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: standard_name_
@@ -229,4 +232,8 @@
       ENDIF
 
+      IF (PRESENT(scalar_ref_)) THEN
+        CALL cxios_set_field_scalar_ref(field_hdl%daddr, scalar_ref_, len(scalar_ref_))
+      ENDIF
+
       IF (PRESENT(scale_factor_)) THEN
         CALL cxios_set_field_scale_factor(field_hdl%daddr, scale_factor_)
@@ -263,5 +270,5 @@
     ( field_id, add_offset, axis_ref, compression_level, default_value, detect_missing_value, domain_ref  &
     , enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, indexed_output, level, long_name  &
-    , name, operation, prec, read_access, scale_factor, standard_name, ts_enabled, ts_split_freq  &
+    , name, operation, prec, read_access, scalar_ref, scale_factor, standard_name, ts_enabled, ts_split_freq  &
     , unit, valid_max, valid_min )
 
@@ -292,4 +299,5 @@
       LOGICAL  , OPTIONAL, INTENT(OUT) :: read_access
       LOGICAL (KIND=C_BOOL) :: read_access_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: scalar_ref
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: scale_factor
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: standard_name
@@ -305,5 +313,5 @@
       ( field_hdl, add_offset, axis_ref, compression_level, default_value, detect_missing_value, domain_ref  &
       , enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, indexed_output, level, long_name  &
-      , name, operation, prec, read_access, scale_factor, standard_name, ts_enabled, ts_split_freq  &
+      , name, operation, prec, read_access, scalar_ref, scale_factor, standard_name, ts_enabled, ts_split_freq  &
       , unit, valid_max, valid_min )
 
@@ -313,5 +321,5 @@
     ( field_hdl, add_offset, axis_ref, compression_level, default_value, detect_missing_value, domain_ref  &
     , enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, indexed_output, level, long_name  &
-    , name, operation, prec, read_access, scale_factor, standard_name, ts_enabled, ts_split_freq  &
+    , name, operation, prec, read_access, scalar_ref, scale_factor, standard_name, ts_enabled, ts_split_freq  &
     , unit, valid_max, valid_min )
 
@@ -341,4 +349,5 @@
       LOGICAL  , OPTIONAL, INTENT(OUT) :: read_access
       LOGICAL (KIND=C_BOOL) :: read_access_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: scalar_ref
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: scale_factor
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: standard_name
@@ -353,5 +362,5 @@
       ( field_hdl, add_offset, axis_ref, compression_level, default_value, detect_missing_value, domain_ref  &
       , enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, indexed_output, level, long_name  &
-      , name, operation, prec, read_access, scale_factor, standard_name, ts_enabled, ts_split_freq  &
+      , name, operation, prec, read_access, scalar_ref, scale_factor, standard_name, ts_enabled, ts_split_freq  &
       , unit, valid_max, valid_min )
 
@@ -361,5 +370,5 @@
     ( field_hdl, add_offset_, axis_ref_, compression_level_, default_value_, detect_missing_value_  &
     , domain_ref_, enabled_, field_ref_, freq_offset_, freq_op_, grid_path_, grid_ref_, indexed_output_  &
-    , level_, long_name_, name_, operation_, prec_, read_access_, scale_factor_, standard_name_  &
+    , level_, long_name_, name_, operation_, prec_, read_access_, scalar_ref_, scale_factor_, standard_name_  &
     , ts_enabled_, ts_split_freq_, unit_, valid_max_, valid_min_ )
 
@@ -389,4 +398,5 @@
       LOGICAL  , OPTIONAL, INTENT(OUT) :: read_access_
       LOGICAL (KIND=C_BOOL) :: read_access__tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: scalar_ref_
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: scale_factor_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: standard_name_
@@ -478,4 +488,8 @@
       ENDIF
 
+      IF (PRESENT(scalar_ref_)) THEN
+        CALL cxios_get_field_scalar_ref(field_hdl%daddr, scalar_ref_, len(scalar_ref_))
+      ENDIF
+
       IF (PRESENT(scale_factor_)) THEN
         CALL cxios_get_field_scale_factor(field_hdl%daddr, scale_factor_)
@@ -512,5 +526,5 @@
     ( field_id, add_offset, axis_ref, compression_level, default_value, detect_missing_value, domain_ref  &
     , enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, indexed_output, level, long_name  &
-    , name, operation, prec, read_access, scale_factor, standard_name, ts_enabled, ts_split_freq  &
+    , name, operation, prec, read_access, scalar_ref, scale_factor, standard_name, ts_enabled, ts_split_freq  &
     , unit, valid_max, valid_min )
 
@@ -556,4 +570,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: read_access
       LOGICAL(KIND=C_BOOL) :: read_access_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: scalar_ref
+      LOGICAL(KIND=C_BOOL) :: scalar_ref_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: scale_factor
       LOGICAL(KIND=C_BOOL) :: scale_factor_tmp
@@ -575,5 +591,5 @@
       ( field_hdl, add_offset, axis_ref, compression_level, default_value, detect_missing_value, domain_ref  &
       , enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, indexed_output, level, long_name  &
-      , name, operation, prec, read_access, scale_factor, standard_name, ts_enabled, ts_split_freq  &
+      , name, operation, prec, read_access, scalar_ref, scale_factor, standard_name, ts_enabled, ts_split_freq  &
       , unit, valid_max, valid_min )
 
@@ -583,5 +599,5 @@
     ( field_hdl, add_offset, axis_ref, compression_level, default_value, detect_missing_value, domain_ref  &
     , enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, indexed_output, level, long_name  &
-    , name, operation, prec, read_access, scale_factor, standard_name, ts_enabled, ts_split_freq  &
+    , name, operation, prec, read_access, scalar_ref, scale_factor, standard_name, ts_enabled, ts_split_freq  &
     , unit, valid_max, valid_min )
 
@@ -626,4 +642,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: read_access
       LOGICAL(KIND=C_BOOL) :: read_access_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: scalar_ref
+      LOGICAL(KIND=C_BOOL) :: scalar_ref_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: scale_factor
       LOGICAL(KIND=C_BOOL) :: scale_factor_tmp
@@ -644,5 +662,5 @@
       ( field_hdl, add_offset, axis_ref, compression_level, default_value, detect_missing_value, domain_ref  &
       , enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, indexed_output, level, long_name  &
-      , name, operation, prec, read_access, scale_factor, standard_name, ts_enabled, ts_split_freq  &
+      , name, operation, prec, read_access, scalar_ref, scale_factor, standard_name, ts_enabled, ts_split_freq  &
       , unit, valid_max, valid_min )
 
@@ -652,5 +670,5 @@
     ( field_hdl, add_offset_, axis_ref_, compression_level_, default_value_, detect_missing_value_  &
     , domain_ref_, enabled_, field_ref_, freq_offset_, freq_op_, grid_path_, grid_ref_, indexed_output_  &
-    , level_, long_name_, name_, operation_, prec_, read_access_, scale_factor_, standard_name_  &
+    , level_, long_name_, name_, operation_, prec_, read_access_, scalar_ref_, scale_factor_, standard_name_  &
     , ts_enabled_, ts_split_freq_, unit_, valid_max_, valid_min_ )
 
@@ -695,4 +713,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: read_access_
       LOGICAL(KIND=C_BOOL) :: read_access__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: scalar_ref_
+      LOGICAL(KIND=C_BOOL) :: scalar_ref__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: scale_factor_
       LOGICAL(KIND=C_BOOL) :: scale_factor__tmp
@@ -805,4 +825,9 @@
       ENDIF
 
+      IF (PRESENT(scalar_ref_)) THEN
+        scalar_ref__tmp = cxios_is_defined_field_scalar_ref(field_hdl%daddr)
+        scalar_ref_ = scalar_ref__tmp
+      ENDIF
+
       IF (PRESENT(scale_factor_)) THEN
         scale_factor__tmp = cxios_is_defined_field_scale_factor(field_hdl%daddr)
Index: XIOS/trunk/src/interface/fortran_attr/ifieldgroup_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/ifieldgroup_attr.F90	(revision 886)
+++ XIOS/trunk/src/interface/fortran_attr/ifieldgroup_attr.F90	(revision 891)
@@ -14,6 +14,6 @@
     ( fieldgroup_id, add_offset, axis_ref, compression_level, default_value, detect_missing_value  &
     , domain_ref, enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, group_ref, indexed_output  &
-    , level, long_name, name, operation, prec, read_access, scale_factor, standard_name, ts_enabled  &
-    , ts_split_freq, unit, valid_max, valid_min )
+    , level, long_name, name, operation, prec, read_access, scalar_ref, scale_factor, standard_name  &
+    , ts_enabled, ts_split_freq, unit, valid_max, valid_min )
 
     IMPLICIT NONE
@@ -44,4 +44,5 @@
       LOGICAL  , OPTIONAL, INTENT(IN) :: read_access
       LOGICAL (KIND=C_BOOL) :: read_access_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: scalar_ref
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: scale_factor
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: standard_name
@@ -57,6 +58,6 @@
       ( fieldgroup_hdl, add_offset, axis_ref, compression_level, default_value, detect_missing_value  &
       , domain_ref, enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, group_ref, indexed_output  &
-      , level, long_name, name, operation, prec, read_access, scale_factor, standard_name, ts_enabled  &
-      , ts_split_freq, unit, valid_max, valid_min )
+      , level, long_name, name, operation, prec, read_access, scalar_ref, scale_factor, standard_name  &
+      , ts_enabled, ts_split_freq, unit, valid_max, valid_min )
 
   END SUBROUTINE xios(set_fieldgroup_attr)
@@ -65,6 +66,6 @@
     ( fieldgroup_hdl, add_offset, axis_ref, compression_level, default_value, detect_missing_value  &
     , domain_ref, enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, group_ref, indexed_output  &
-    , level, long_name, name, operation, prec, read_access, scale_factor, standard_name, ts_enabled  &
-    , ts_split_freq, unit, valid_max, valid_min )
+    , level, long_name, name, operation, prec, read_access, scalar_ref, scale_factor, standard_name  &
+    , ts_enabled, ts_split_freq, unit, valid_max, valid_min )
 
     IMPLICIT NONE
@@ -94,4 +95,5 @@
       LOGICAL  , OPTIONAL, INTENT(IN) :: read_access
       LOGICAL (KIND=C_BOOL) :: read_access_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: scalar_ref
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: scale_factor
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: standard_name
@@ -106,6 +108,6 @@
       ( fieldgroup_hdl, add_offset, axis_ref, compression_level, default_value, detect_missing_value  &
       , domain_ref, enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, group_ref, indexed_output  &
-      , level, long_name, name, operation, prec, read_access, scale_factor, standard_name, ts_enabled  &
-      , ts_split_freq, unit, valid_max, valid_min )
+      , level, long_name, name, operation, prec, read_access, scalar_ref, scale_factor, standard_name  &
+      , ts_enabled, ts_split_freq, unit, valid_max, valid_min )
 
   END SUBROUTINE xios(set_fieldgroup_attr_hdl)
@@ -114,5 +116,5 @@
     ( fieldgroup_hdl, add_offset_, axis_ref_, compression_level_, default_value_, detect_missing_value_  &
     , domain_ref_, enabled_, field_ref_, freq_offset_, freq_op_, grid_path_, grid_ref_, group_ref_  &
-    , indexed_output_, level_, long_name_, name_, operation_, prec_, read_access_, scale_factor_  &
+    , indexed_output_, level_, long_name_, name_, operation_, prec_, read_access_, scalar_ref_, scale_factor_  &
     , standard_name_, ts_enabled_, ts_split_freq_, unit_, valid_max_, valid_min_ )
 
@@ -143,4 +145,5 @@
       LOGICAL  , OPTIONAL, INTENT(IN) :: read_access_
       LOGICAL (KIND=C_BOOL) :: read_access__tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: scalar_ref_
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: scale_factor_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: standard_name_
@@ -236,4 +239,8 @@
       ENDIF
 
+      IF (PRESENT(scalar_ref_)) THEN
+        CALL cxios_set_fieldgroup_scalar_ref(fieldgroup_hdl%daddr, scalar_ref_, len(scalar_ref_))
+      ENDIF
+
       IF (PRESENT(scale_factor_)) THEN
         CALL cxios_set_fieldgroup_scale_factor(fieldgroup_hdl%daddr, scale_factor_)
@@ -270,6 +277,6 @@
     ( fieldgroup_id, add_offset, axis_ref, compression_level, default_value, detect_missing_value  &
     , domain_ref, enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, group_ref, indexed_output  &
-    , level, long_name, name, operation, prec, read_access, scale_factor, standard_name, ts_enabled  &
-    , ts_split_freq, unit, valid_max, valid_min )
+    , level, long_name, name, operation, prec, read_access, scalar_ref, scale_factor, standard_name  &
+    , ts_enabled, ts_split_freq, unit, valid_max, valid_min )
 
     IMPLICIT NONE
@@ -300,4 +307,5 @@
       LOGICAL  , OPTIONAL, INTENT(OUT) :: read_access
       LOGICAL (KIND=C_BOOL) :: read_access_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: scalar_ref
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: scale_factor
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: standard_name
@@ -313,6 +321,6 @@
       ( fieldgroup_hdl, add_offset, axis_ref, compression_level, default_value, detect_missing_value  &
       , domain_ref, enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, group_ref, indexed_output  &
-      , level, long_name, name, operation, prec, read_access, scale_factor, standard_name, ts_enabled  &
-      , ts_split_freq, unit, valid_max, valid_min )
+      , level, long_name, name, operation, prec, read_access, scalar_ref, scale_factor, standard_name  &
+      , ts_enabled, ts_split_freq, unit, valid_max, valid_min )
 
   END SUBROUTINE xios(get_fieldgroup_attr)
@@ -321,6 +329,6 @@
     ( fieldgroup_hdl, add_offset, axis_ref, compression_level, default_value, detect_missing_value  &
     , domain_ref, enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, group_ref, indexed_output  &
-    , level, long_name, name, operation, prec, read_access, scale_factor, standard_name, ts_enabled  &
-    , ts_split_freq, unit, valid_max, valid_min )
+    , level, long_name, name, operation, prec, read_access, scalar_ref, scale_factor, standard_name  &
+    , ts_enabled, ts_split_freq, unit, valid_max, valid_min )
 
     IMPLICIT NONE
@@ -350,4 +358,5 @@
       LOGICAL  , OPTIONAL, INTENT(OUT) :: read_access
       LOGICAL (KIND=C_BOOL) :: read_access_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: scalar_ref
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: scale_factor
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: standard_name
@@ -362,6 +371,6 @@
       ( fieldgroup_hdl, add_offset, axis_ref, compression_level, default_value, detect_missing_value  &
       , domain_ref, enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, group_ref, indexed_output  &
-      , level, long_name, name, operation, prec, read_access, scale_factor, standard_name, ts_enabled  &
-      , ts_split_freq, unit, valid_max, valid_min )
+      , level, long_name, name, operation, prec, read_access, scalar_ref, scale_factor, standard_name  &
+      , ts_enabled, ts_split_freq, unit, valid_max, valid_min )
 
   END SUBROUTINE xios(get_fieldgroup_attr_hdl)
@@ -370,5 +379,5 @@
     ( fieldgroup_hdl, add_offset_, axis_ref_, compression_level_, default_value_, detect_missing_value_  &
     , domain_ref_, enabled_, field_ref_, freq_offset_, freq_op_, grid_path_, grid_ref_, group_ref_  &
-    , indexed_output_, level_, long_name_, name_, operation_, prec_, read_access_, scale_factor_  &
+    , indexed_output_, level_, long_name_, name_, operation_, prec_, read_access_, scalar_ref_, scale_factor_  &
     , standard_name_, ts_enabled_, ts_split_freq_, unit_, valid_max_, valid_min_ )
 
@@ -399,4 +408,5 @@
       LOGICAL  , OPTIONAL, INTENT(OUT) :: read_access_
       LOGICAL (KIND=C_BOOL) :: read_access__tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: scalar_ref_
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: scale_factor_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: standard_name_
@@ -492,4 +502,8 @@
       ENDIF
 
+      IF (PRESENT(scalar_ref_)) THEN
+        CALL cxios_get_fieldgroup_scalar_ref(fieldgroup_hdl%daddr, scalar_ref_, len(scalar_ref_))
+      ENDIF
+
       IF (PRESENT(scale_factor_)) THEN
         CALL cxios_get_fieldgroup_scale_factor(fieldgroup_hdl%daddr, scale_factor_)
@@ -526,6 +540,6 @@
     ( fieldgroup_id, add_offset, axis_ref, compression_level, default_value, detect_missing_value  &
     , domain_ref, enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, group_ref, indexed_output  &
-    , level, long_name, name, operation, prec, read_access, scale_factor, standard_name, ts_enabled  &
-    , ts_split_freq, unit, valid_max, valid_min )
+    , level, long_name, name, operation, prec, read_access, scalar_ref, scale_factor, standard_name  &
+    , ts_enabled, ts_split_freq, unit, valid_max, valid_min )
 
     IMPLICIT NONE
@@ -572,4 +586,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: read_access
       LOGICAL(KIND=C_BOOL) :: read_access_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: scalar_ref
+      LOGICAL(KIND=C_BOOL) :: scalar_ref_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: scale_factor
       LOGICAL(KIND=C_BOOL) :: scale_factor_tmp
@@ -591,6 +607,6 @@
       ( fieldgroup_hdl, add_offset, axis_ref, compression_level, default_value, detect_missing_value  &
       , domain_ref, enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, group_ref, indexed_output  &
-      , level, long_name, name, operation, prec, read_access, scale_factor, standard_name, ts_enabled  &
-      , ts_split_freq, unit, valid_max, valid_min )
+      , level, long_name, name, operation, prec, read_access, scalar_ref, scale_factor, standard_name  &
+      , ts_enabled, ts_split_freq, unit, valid_max, valid_min )
 
   END SUBROUTINE xios(is_defined_fieldgroup_attr)
@@ -599,6 +615,6 @@
     ( fieldgroup_hdl, add_offset, axis_ref, compression_level, default_value, detect_missing_value  &
     , domain_ref, enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, group_ref, indexed_output  &
-    , level, long_name, name, operation, prec, read_access, scale_factor, standard_name, ts_enabled  &
-    , ts_split_freq, unit, valid_max, valid_min )
+    , level, long_name, name, operation, prec, read_access, scalar_ref, scale_factor, standard_name  &
+    , ts_enabled, ts_split_freq, unit, valid_max, valid_min )
 
     IMPLICIT NONE
@@ -644,4 +660,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: read_access
       LOGICAL(KIND=C_BOOL) :: read_access_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: scalar_ref
+      LOGICAL(KIND=C_BOOL) :: scalar_ref_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: scale_factor
       LOGICAL(KIND=C_BOOL) :: scale_factor_tmp
@@ -662,6 +680,6 @@
       ( fieldgroup_hdl, add_offset, axis_ref, compression_level, default_value, detect_missing_value  &
       , domain_ref, enabled, field_ref, freq_offset, freq_op, grid_path, grid_ref, group_ref, indexed_output  &
-      , level, long_name, name, operation, prec, read_access, scale_factor, standard_name, ts_enabled  &
-      , ts_split_freq, unit, valid_max, valid_min )
+      , level, long_name, name, operation, prec, read_access, scalar_ref, scale_factor, standard_name  &
+      , ts_enabled, ts_split_freq, unit, valid_max, valid_min )
 
   END SUBROUTINE xios(is_defined_fieldgroup_attr_hdl)
@@ -670,5 +688,5 @@
     ( fieldgroup_hdl, add_offset_, axis_ref_, compression_level_, default_value_, detect_missing_value_  &
     , domain_ref_, enabled_, field_ref_, freq_offset_, freq_op_, grid_path_, grid_ref_, group_ref_  &
-    , indexed_output_, level_, long_name_, name_, operation_, prec_, read_access_, scale_factor_  &
+    , indexed_output_, level_, long_name_, name_, operation_, prec_, read_access_, scalar_ref_, scale_factor_  &
     , standard_name_, ts_enabled_, ts_split_freq_, unit_, valid_max_, valid_min_ )
 
@@ -715,4 +733,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: read_access_
       LOGICAL(KIND=C_BOOL) :: read_access__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: scalar_ref_
+      LOGICAL(KIND=C_BOOL) :: scalar_ref__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: scale_factor_
       LOGICAL(KIND=C_BOOL) :: scale_factor__tmp
@@ -830,4 +850,9 @@
       ENDIF
 
+      IF (PRESENT(scalar_ref_)) THEN
+        scalar_ref__tmp = cxios_is_defined_fieldgroup_scalar_ref(fieldgroup_hdl%daddr)
+        scalar_ref_ = scalar_ref__tmp
+      ENDIF
+
       IF (PRESENT(scale_factor_)) THEN
         scale_factor__tmp = cxios_is_defined_fieldgroup_scale_factor(fieldgroup_hdl%daddr)
